<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Service 1</title>
    <link rel="stylesheet" href="style.css">
</head>
<body>
    <header class="header-main">
        <nav class="header-main-nav">
            <ul>
                <li><a href="index.html">Home</a></li>
                <li>
                    <a href="WeeklyAssignment.html">Weekly Assignment</a>
                    <div class="dropdown-content">
                        <a href="Week1.html">Week 1:Introduction</a>
                        <a href="Week2.html">Week 2:Principles and Practice</a>
                        <a href="Week3.html">Week 3:Project Management</a>
                        <a href="Week4.html">Week 4:Computer-Aided Design</a>
                        <a href="Week5.html">Week 5:Computer-Controlled Cutting</a>
                        <a href="Week6.html">Week 6:Electronics Production</a>
                        <a href="Week7.html">Week 7:3D Scanning and Printing</a>
                        
                    </div>
                </li>
                <li><a href="about.html">About Me</a></li>
                <li><a href="Final.html">Final Project</a></li>
            </ul>
        </nav>
    </header>

    <div class="main-content">
        <h1>Week 3:Project Management 📁</h1>
        <br><p>The main task this week was to continue refining the webpage as well as organizing the project management methodology and process.</p>
        <div class="grid-container">
            <h2>01.Workflow for creating website</h2>
            <p>Before creating a web page, I tend to build sketches as well as organize the images, text, etc. that I will need for each page so that I have a complete framework in my head when writing code and I can be more efficient.</p>
            <img src="image/sortcontent.webp" alt="sortcontent" style="max-width:100%;">
            <br><br><br><br>
            <h2>02.Create GitLab file</h2>
            <p>Once you've completed the basics of your web page, you can set up your GitLab account. If you don't have a GitLab account, you'll need to register first, which is a very simple process. Once you have registered, you can go to your GitLab homepage and then create a new project and name the file.
            </p>
            <img src="image/creatproject.webp" alt="creatproject" style="max-width:100%;">
            <img src="image/nameit.webp" alt="nameit" style="max-width:100%;">
            <br><br><br><br>
            <p>Files such as html, css, etc. can then be added and made publicly accessible via yml. In GitLab, the .gitlab-ci.yml file is used to define the CI/CD pipeline configuration, which is in YAML format. This file tells the GitLab CI/CD system how to build, test, and deploy your code. The .gitlab-ci.yml file is usually located in the root directory of your project and is automatically read and executed by GitLab CI/CD each time you commit your code.
                <br><br>
                This YAML file defines a series of stages and tasks, each of which can contain a series of script instructions and configuration parameters. When the code is committed to the repository, GitLab CI/CD automatically executes the tasks according to the configuration of this file, thus realizing continuous integration and continuous deployment.</p>
            <img src="image/creathtml.webp" alt="creathtml" style="max-width:100%;">
            <img src="image/yml.webp" alt="yml" style="max-width:100%;">
            <h2>03.Download Git and set up SSH Key</h2>
            <p>What's Git? Git is a free and open source distributed version control system. It handles projects of all sizes quickly and efficiently, while providing support for rolling back changes when needed.<br><br>
                In short, Git bridges the gap between your local system and GitLab, making it faster and easier to modify and transfer files.To use this tool, you must first download it from Git's official <a href="https://git-scm.com/downloads">website</a> .</p>
            <img src="image/git.webp" alt="git" style="max-width:100%;" >
            <br><br><br><p>Once you have downloaded and installed Git, you can add your SSH Key! At this point we need to open the terminal and complete the following steps: 1. Generate a key pair 2. Add the public key to GitLab 3. Create a local repository and synchronize the file transfer to GitLab
            </p>
            <h3>Generate a key pair</h3>
            <p>The key pair consists of a public key and a private key. The public key is to be published to GitLab, while the private key is stored on the local computer and cannot be seen by others; a successful pairing of the public and private keys is required to establish a connection.
               <br><br>
                The first time you set up may be confused, I set it up myself by referring to the online experience, and it's actually quite simple.
            </p>
            <p class="terminal">ssh-keygen -t rsa -b 4096 -C youremail@email.com
            </p>
            <br><br>
            <p>Keep pressing enter until the following pattern appears
            </p>
            <img src="image/terminal-ssh.webp" alt="terminal-ssh" style="max-width:100%;"  >
            <br><br> <br><br>
            <p>Open the public key file and copy the public key to GitLab (Profile- Preferences- SSH Keys-Add New key)Once copied you can clone the GitLab repository locally, by typing git clone + clone code on Gitlab in the terminal:</p>
            <p class="terminal">git clone git@gitlab.com:juening/digital-fabrication-i.git
            </p>
            <br><br>
            <p>The following code appears to indicate that the cloning was successful</p>
            <img src="image/clonedone.webp" alt="clonedone" style="max-width:100%;">
            <br><br>
            <p>A successful clone means that the repository on GitLab has been copied to your local computer. You can then edit and manage these files locally, and then use Git to push changes back to GitLab.You can use the following commands to perform common Git operations:</p>
            <img src="image/gpt1.webp" alt="gpt1" style="max-width:100%;">
            <img src="image/gpt2.webp" alt="gpt2" style="max-width:100%;">
            <img src="image/gpt3.webp" alt="gpt3" style="max-width:100%;">
            <br><br>
            <p>After completing the series of operations, you will find that the GitLab file automatically matches the local file! Of course, if you make any subsequent changes, you'll need to continue with these steps, but it's easy! ✌️</p>
        </div>
        <br><br><p class="Go">Go to  <a href="Week4.html" >next week -></a></p><br><br>
    </div>






    
    <footer class="footer-main">
        <span class="footer">&copy; 2024 Jue Ning. All rights reserved.</span>
    </footer>
</body>
</html>
